#include <SDL.h>
#include <cmath>

SDL_Point Transformar(SDL_Point p, float alfa, float escala, int dx, int dy);

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Renderer *renderer;
    const int nPuntos = 13;
    const SDL_Point puntos[nPuntos] = {
        {-5,-21}, {8,-14}, {21,-22}, {33,-7}, {21,0},
        {33,12}, {21,31}, {1,25}, {-6,32}, {-20,18},
        {-14,5}, {-19,-7}, {-5,-21}};
    SDL_Point puntos2[nPuntos];
    int i;
    float alfa=0, escala=1;
    int dx=0, dy=0;

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow("Mi primera ventana",
        SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS);
    renderer = SDL_CreateRenderer(ventana, -1, 0);

    do {
        SDL_SetRenderDrawColor(renderer, 0,0,0,255);
        SDL_RenderClear(renderer);

        for(int p=0; p<nPuntos; p++) {
            puntos2[p] = Transformar(puntos[p], alfa, escala, dx, dy);
        }
        alfa += 5.0*3.1416/180.0; // rotar 5 grados
        escala += 0.008;
        dx += 2;
        dy += 1;
        SDL_SetRenderDrawColor(renderer, 255,255,255,255);
        SDL_RenderDrawLines(renderer, puntos2, nPuntos);
        SDL_RenderPresent(renderer);
        SDL_Delay(30);
    } while(i++ < 300);
    SDL_Delay(5000);

    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}

SDL_Point Transformar(SDL_Point p, float alfa, float escala, int dx, int dy) {
    SDL_Point retval;

    retval.x = p.x*escala*std::cos(alfa) - p.y*escala*std::sin(alfa) + dx;
    retval.y = p.x*escala*std::sin(alfa) + p.y*escala*std::cos(alfa) + dy;

    return retval;
}
